"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/mendertooltip.js
var mendertooltip_exports = {};
__export(mendertooltip_exports, {
  HelpTooltip: () => HelpTooltip,
  MenderTooltip: () => MenderTooltip,
  MenderTooltipClickable: () => MenderTooltipClickable,
  OnboardingTooltip: () => OnboardingTooltip,
  default: () => mendertooltip_default
});
module.exports = __toCommonJS(mendertooltip_exports);
var import_react = __toESM(require("react"), 1);
var import_icons_material = require("@mui/icons-material");
var import_material = require("@mui/material");
var import_mui = require("tss-react/mui");
var import_constants = require("@northern.tech/store/constants");
var import_debouncehook = require("@northern.tech/utils/debouncehook");
var import_helpers = require("@northern.tech/utils/helpers");
var import_jsx_runtime = require("react/jsx-runtime");
var useStyles = (0, import_mui.makeStyles)()((theme) => ({
  icon: {
    "&.read": {
      color: theme.palette.text.disabled
    }
  },
  iconAura: {
    position: "absolute",
    top: -5,
    bottom: 0,
    left: -5,
    right: -5,
    border: `1px dashed ${theme.palette.primary.main}`,
    borderRadius: "50%",
    "&.read": {
      borderColor: theme.palette.text.disabled
    }
  }
}));
var MenderTooltip = (0, import_mui.withStyles)(import_material.Tooltip, ({ palette, shadows, spacing }) => ({
  arrow: {
    color: palette.background.paper
  },
  tooltip: {
    backgroundColor: palette.background.paper,
    boxShadow: shadows[1],
    color: palette.text.primary,
    padding: spacing(2),
    fontSize: "small",
    maxWidth: 600,
    info: {
      maxWidth: 300,
      color: palette.text.hint,
      backgroundColor: palette.grey[500]
    }
  }
}));
var MenderTooltipClickable = ({
  children,
  onboarding,
  startOpen = false,
  visibility = startOpen,
  onOpenChange,
  tooltipComponent = MenderTooltip,
  ...remainingProps
}) => {
  const [open, setOpen] = (0, import_react.useState)(startOpen || false);
  (0, import_react.useEffect)(() => {
    setOpen(visibility);
  }, [visibility]);
  (0, import_react.useEffect)(() => {
    if (!onOpenChange) {
      return;
    }
    onOpenChange(open);
  }, [open, onOpenChange]);
  const toggleVisibility = () => setOpen(import_helpers.toggle);
  const hide = () => setOpen(false);
  const Component = onboarding ? OnboardingTooltip : tooltipComponent;
  const extraProps = onboarding ? {
    PopperProps: {
      disablePortal: true,
      popperOptions: {
        strategy: "fixed",
        modifiers: [
          { name: "flip", enabled: false },
          { name: "preventOverflow", enabled: true, options: { boundary: window, altBoundary: false } }
        ]
      }
    }
  } : {};
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_material.ClickAwayListener, { onClickAway: hide, children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
    Component,
    {
      arrow: !onboarding,
      open,
      disableFocusListener: true,
      disableHoverListener: true,
      disableTouchListener: true,
      onOpen: () => setOpen(true),
      ...extraProps,
      ...remainingProps,
      children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)("div", { onClick: toggleVisibility, children })
    }
  ) });
};
var iconWidth = 30;
var OnboardingTooltip = (0, import_mui.withStyles)(import_material.Tooltip, (theme) => ({
  arrow: {
    color: theme.palette.primary.main
  },
  tooltip: {
    backgroundColor: theme.palette.primary.main,
    boxShadow: theme.shadows[1],
    color: theme.palette.grey[500],
    fontSize: 14,
    maxWidth: 350,
    padding: "12px 18px",
    width: 350,
    "& a": {
      color: theme.palette.grey[500]
    },
    "&.MuiTooltip-tooltipPlacementTop": { marginLeft: iconWidth, marginBottom: 0, marginTop: `calc(${iconWidth} + ${theme.spacing(1.5)})` },
    "&.MuiTooltip-tooltipPlacementRight": { marginTop: iconWidth / 2 },
    "&.MuiTooltip-tooltipPlacementBottom": { marginLeft: iconWidth },
    "&.MuiTooltip-tooltipPlacementLeft": { marginTop: iconWidth / 2 }
  },
  popper: {
    opacity: 0.9
  }
}));
var mendertooltip_default = MenderTooltip;
var tooltipStateStyleMap = {
  [import_constants.READ_STATES.read]: "read muted",
  default: ""
};
var TooltipWrapper = ({ content, onClose, onReadAll }) => /* @__PURE__ */ (0, import_jsx_runtime.jsxs)("div", { children: [
  content,
  /* @__PURE__ */ (0, import_jsx_runtime.jsxs)("div", { className: "flexbox space-between margin-top-small", children: [
    /* @__PURE__ */ (0, import_jsx_runtime.jsx)("span", { className: "link", onClick: onReadAll, children: "Mark all help tips as read" }),
    /* @__PURE__ */ (0, import_jsx_runtime.jsx)("span", { className: "link", onClick: onClose, children: "Close" })
  ] })
] });
var HelpTooltip = ({ icon = void 0, id, contentProps = {}, tooltip, device, setAllTooltipsReadState, setTooltipReadState, ...props }) => {
  const [isOpen, setIsOpen] = (0, import_react.useState)(false);
  const debouncedIsOpen = (0, import_debouncehook.useDebounce)(isOpen, import_constants.TIMEOUTS.threeSeconds);
  const { classes } = useStyles();
  const { Component, SpecialComponent, isRelevant, readState } = tooltip;
  (0, import_react.useEffect)(() => {
    if (!debouncedIsOpen) {
      return;
    }
    setTooltipReadState({ id, persist: true, readState: import_constants.READ_STATES.read });
  }, [debouncedIsOpen, id, setTooltipReadState]);
  const onReadAllClick = () => setAllTooltipsReadState(import_constants.READ_STATES.read);
  const title = SpecialComponent ? /* @__PURE__ */ (0, import_jsx_runtime.jsx)(SpecialComponent, { device, ...contentProps }) : /* @__PURE__ */ (0, import_jsx_runtime.jsx)(TooltipWrapper, { content: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(Component, { device, ...contentProps }), onClose: () => setIsOpen(false), onReadAll: onReadAllClick });
  if (!isRelevant({ device, ...contentProps })) {
    return null;
  }
  const className = tooltipStateStyleMap[readState] ?? tooltipStateStyleMap.default;
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(MenderTooltipClickable, { className: isOpen ? "muted" : "", title, visibility: isOpen, onOpenChange: setIsOpen, ...props, children: /* @__PURE__ */ (0, import_jsx_runtime.jsxs)("div", { className: "relative", children: [
    icon || /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_icons_material.Help, { className: `${classes.icon} ${className}`, color: "primary" }),
    /* @__PURE__ */ (0, import_jsx_runtime.jsx)("div", { className: `${classes.iconAura} ${className}` })
  ] }) });
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  HelpTooltip,
  MenderTooltip,
  MenderTooltipClickable,
  OnboardingTooltip
});
//# sourceMappingURL=mendertooltip.cjs.map